package bg.bas.dcl.multilingual.ClauseSplitting.rules;

import java.util.ArrayList;
import java.util.HashMap;

import bg.bas.dcl.entities.Conjunction;
import bg.bas.dcl.entities.Sentence;
import bg.bas.dcl.entities.VerbForm;
import bg.bas.dcl.multilingual.Chunker.VerbFormRecogniser.ClauseVerb;
import bg.bas.dcl.multilingual.ClauseSplitting.ClauseBorder;
import bg.bas.dcl.multilingual.ClauseSplitting.ClauseSplittingComplexObject;
import bg.bas.dcl.multilingual.ClauseSplitting.ClauseStack;

public class ParenthericalsClauseSplittingRule implements ClauseSplittingRule {
	
	public boolean isEndingRule = false;
	
	ArrayList<Conjunction> conjList = new ArrayList<Conjunction>();
	
	public ParenthericalsClauseSplittingRule () {
		
		System.out.println(conjList.size());

	}

	
	public ClauseSplittingComplexObject findClauseBorders(
			Sentence sentence,
			ArrayList<ClauseVerb> verbs, 
			int spos, int epos,
			ClauseStack stack
			){
		
		ClauseSplittingComplexObject obj = new ClauseSplittingComplexObject();
		obj.cls = stack;
		obj.clborders = new ArrayList<ClauseBorder>();
		
		VerbForm vf = new VerbForm();
		for (int i = 1; i<verbs.size(); i++) {
			VerbForm v = verbs.get(i);
			
			if (v.get(0).sentpos >= epos) {
				vf = v;
				break;
			}
		}
		

			
		if (sentence.get(epos).lemma.equals(",") && !fullVerb(vf) && vf.get(0).sentpos==epos+1) {

			obj.clborders.add(new ClauseBorder(epos+1, "PCOS"));
			obj.cls.putInStack("PCOS", epos+1);
		}

		/**
		if (obj.cls.getTypeFromStack(1).equals("SCOC")){
			spos = Math.max(obj.cls.getIndexFromStack(1),spos);
		}
		
		if (obj.cls.stackSize()>0 && spos < obj.cls.getIndexFromStack(1)) {
			spos = obj.cls.getIndexFromStack(1);
		}
		
		
		VerbForm vf = new VerbForm();
		for (VerbForm v : verbs) {
			if (v.get(0) >= spos && sentence.get(v.get(0)).clauseID==sentence.get(spos).clauseID) {
				vf = v;
				break;
			}
		}
		
		boolean fullVerb = true;
		for (String t : vf.tense) {
			if (t.startsWith("NVerb")) {
				fullVerb = false;
				
				break;
			}
		}			

		for (int i=spos; i<epos+1; i++) {
			
			if (!fullVerb && vf.contains(i) 
					&& ((i > 0 && sentence.get(i-1).wordform.equals(","))
							|| i==0)) {
				
//			System.err.println(sentence.get(i).wordform);System.exit(0);
				
				obj.clborders.add(new ClauseBorder(i, "PCOS"));
				obj.cls.putInStack("PCOS", i);

			}
		}
		*/
		
		return obj;
		
	}
	
	public boolean fullVerb(VerbForm vf){
		boolean fullVerb = true;
		for (String t : vf.tense) {
			if (t.startsWith("NVerb")) {
				fullVerb = false;
				
				break;
			}
		}			
		return fullVerb;
	}
	
	public boolean isEnding(){
		return isEndingRule;
	}


}
