package bg.bas.dcl.entities;

public class TextPosition {
	

	public int parpos = -1;
	public int sentpos = -1;
	
	public TextPosition(int pp, int sp) {
		parpos = pp;
		sentpos = sp;
	}

	public boolean isBetween(TextPosition b, TextPosition e){
		if (parpos<b.parpos) return false;
		if (parpos>e.parpos) return false;

		if (parpos == b.parpos && sentpos < b.sentpos) return false;
		if (parpos == e.parpos && sentpos > e.sentpos) return false;
		
		return true;
	}

	public boolean isBefore(TextPosition b){
		if (parpos>b.parpos) return false;

		if (parpos == b.parpos && sentpos > b.sentpos) return false;
		
		return true;
	}

	public boolean isAfter(TextPosition b){
				return b.isBefore(this);
	}

	public boolean isEqual(TextPosition b){
		return (parpos == b.parpos && sentpos == b.sentpos);
	}

	public boolean isInSameSentance(TextPosition b){
		return (parpos == b.parpos);
	}
	
	

}
