package bg.bas.dcl.general;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;


public class FileDownloader {
	
	FileHandler fh = new FileHandler();
	
	public void downloadAllHierarchy(String startingUrl){
		
		try{
			
			URL url = new URL(startingUrl);
			
			String contents = readContents(startingUrl,"Windows-1251");
			
			System.out.println(contents);
//			saveFileFromUrl(String urlString,String filename) 
			
			
		}catch(Exception e){
			e.printStackTrace();
		}
		
		
	}
	
	
	public void getOriginalContent(String url, String filename,String encoding){

        try {
        	
         	URLConnection connection =  new URL(url).openConnection();
        	
        	System.err.println(connection.getURL());
        	
        	InputStream resultingInputStream = null;      
 
   	    resultingInputStream = connection.getInputStream();
  
    	    if (new File(filename).isDirectory()
    				|| filename.endsWith("/")) {
            	System.err.println("Out 1");

    			return;
    		}

    	
    		Scanner scanner = new Scanner(resultingInputStream,
            		encoding);
    		String NL = System.getProperty("line.separator");

            FileHandler.makeParent(filename, "/");
    		Writer out = new OutputStreamWriter(
    				new FileOutputStream(filename),
            		encoding);
                
            System.out.println("Url1: "+url);
            System.out.println("Filename1: "+filename);
            
 
read:       while (scanner.hasNextLine()) {
            	

				String line = scanner.nextLine();
            	// whatever is read, is written to a file
                    out.write(line+NL);
                    out.flush();
                    
  //                  System.out.println(line);
            }
            
            scanner.close();
 
            out.flush();
            out.close();

			System.out.println(url+FileHandler.NL
					+"File saved... "+ filename
					);

            System.out.println("Url2: "+url);
            System.out.println("Filename2: "+filename);

            
            
        } catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();

        }

        
	}

	String[] encodings = {"utf-8","windows-1251"};
	public void readContents(String url, String filename,String encoding){
		try{

        FileHandler.makeParent(filename, "/");
                    
	    
	    
		StringBuilder text = new StringBuilder();

			
			URLConnection connection =  new URL(url).openConnection();

			InputStream resultingInputStream = null;      

			resultingInputStream = connection.getInputStream();
			Scanner scanner = new Scanner(resultingInputStream,encoding);
			String NL = System.getProperty("line.separator");
			
			
			while (scanner.hasNextLine()) {
				String line = scanner.nextLine();
				
				text.append(line + NL);
			}
		      
			FileHandler.makeParent(filename, "/");
	
   	    	scanner.close();
  	    	
		fh.saveToFile(text+"", "UTF-8", filename);


		} catch (IOException ioe){
			
		}

		
	}

	public String readContents(String url,String encoding){
		try{

                    
		URLConnection connection =  new URL(url).openConnection();

		System.out.println("exists " + new URL(url).getFile());
		System.out.println("encoding is " + connection.getContentEncoding());
		System.out.println("title is " + connection.getHeaderField("title"));

		InputStream resultingInputStream = null;      
		
	    resultingInputStream = connection.getInputStream();

	
		Scanner scanner = new Scanner(resultingInputStream,encoding);
		String NL = System.getProperty("line.separator");
		
		StringBuilder text = new StringBuilder();
		
		while (scanner.hasNextLine()) {
			String line = scanner.nextLine();
			
			text.append(line + NL);
		}
	      
		
   	    	 
   	    	scanner.close();
   	    	
   	    	return text.toString();

		} catch (IOException ioe){
			
		}

		return "";
	}

	

	
	public String normaliseFilename(String filename, String ext){
		
		String fname = "";
		
		if (filename.endsWith("/")) {
			filename = filename.substring(0, filename.length()-1);
		}
		if (!filename.endsWith("."+ext)) filename += "."+ext;
		filename = filename.replaceAll("//", "/");

		int i = filename.lastIndexOf("/");
		
		fname = filename.substring(i+1);
		filename = filename.substring(0,i+1);
		
		int j = Math.max(-1, fname.lastIndexOf("?"));
		j = Math.max(j, fname.lastIndexOf("="));
		j = Math.max(j, fname.lastIndexOf("&"));
		
		fname = fname.substring(j+1);
		return filename + fname;
	}

	public void saveFileFromUrl(String urlString,String filename) {
		

        try
        {

            BufferedInputStream in = null;
            FileOutputStream fout = null;	

		            in = new BufferedInputStream(new URL(urlString).openStream());
		            fout = new FileOutputStream(filename);

		            byte data[] = new byte[1024];
		            int count;
		            while ((count = in.read(data, 0, 1024)) != -1)
		            {
		                fout.write(data, 0, count);
		            }
		            
		    	    if (in != null)
		    	        in.close();
		    	    if (fout != null)
		    	        fout.close();


		} catch(Exception e){
		        	e.printStackTrace();
		}

	}


}
