package bg.bas.dcl.multilingual.ClauseSplitting.rules;

import java.util.ArrayList;
import java.util.HashMap;

import bg.bas.dcl.entities.Sentence;
import bg.bas.dcl.entities.VerbForm;
import bg.bas.dcl.multilingual.Chunker.VerbFormRecogniser.ClauseVerb;
import bg.bas.dcl.multilingual.ClauseSplitting.ClauseBorder;
import bg.bas.dcl.multilingual.ClauseSplitting.ClauseSplittingComplexObject;
import bg.bas.dcl.multilingual.ClauseSplitting.ClauseStack;

public class EndSentenceClauseSplittingRule implements ClauseSplittingRule {

	public boolean isEndingRule = true;
	
	public ClauseSplittingComplexObject findClauseBorders(
			Sentence sentence,
			ArrayList<ClauseVerb> verbs, 
			int spos, int epos,
			ClauseStack stack
			){

		ClauseSplittingComplexObject obj = new ClauseSplittingComplexObject();
		obj.cls = stack;
		obj.clborders = new ArrayList<ClauseBorder>();

		System.err.println("END CHECK "+epos + "\t"+(sentence.size()-1) + "\t"
					+obj.cls.stackSize());
		
		if (epos < sentence.size()-1) return obj;

		while(stack.stackSize()>0){
			obj.clborders.add(new ClauseBorder(sentence.size()-1, "CC"));
			obj.cls.removeFromStack();
			
		}				

		return obj;

	}
	public boolean isEnding(){
		return isEndingRule;
	}

}
